"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.graphqlFetchOptions = void 0;
/**
 * Gets default [`fetch` options]{@link GraphQLFetchOptions} for a
 * [GraphQL operation]{@link GraphQLOperation}.
 * @param {GraphQLOperation} operation GraphQL operation.
 * @returns {GraphQLFetchOptions} [`fetch`](https://developer.mozilla.org/docs/Web/API/Fetch_API) options.
 * @ignore
 */
function graphqlFetchOptions(operation) {
    var fetchOptions = {
        url: '/graphql',
        method: 'POST',
        headers: { Accept: 'application/json', 'Content-Type': 'application/json' },
    };
    fetchOptions.body = JSON.stringify(operation);
    return fetchOptions;
}
exports.graphqlFetchOptions = graphqlFetchOptions;
//# sourceMappingURL=graphqlFetchOptions.js.map